
**************************
**** GMM HIRM program ****
**************************

* `at'[1,1] : f
* `at'[1,2] : alph
* `at'[1,3] : ln(sigth)
* `at'[1,4] : arctanh(rhoth)
* `at'[1,5] : ln(yh)

program gmm_hirm_simple_h

version 11
syntax varlist if, at(name)

quietly {
		
		tempvar f alph sigth rhoth yh
		tempvar millsx millsd muhd muhx vhd vhx 
				
		gen double `f' = `at'[1,1]
		gen double `alph' = `at'[1,2]
		gen double `sigth' = exp(`at'[1,3])
		gen double `rhoth' = tanh(`at'[1,4])
		gen double `yh' = exp(`at'[1,5])
		
		gen double `millsx' = normalden(`f')/(1-normal(`f')) `if'
		gen double `millsd' = normalden(`f')/normal(`f') `if'
		
		gen double `muhd' = `alph' - ( `sigth'*`rhoth'*`millsd' ) `if'
		gen double `muhx' = `alph' + `yh' + ( `sigth'*`rhoth'*`millsx' ) `if'

		gen double `vhd' = (`sigth'*`sigth') * ( (1-(`rhoth'*`rhoth')) + ((`rhoth'*`rhoth')*(1 - `millsd' * (`millsd' + `f'))) ) `if'
		gen double `vhx' = (`sigth'*`sigth') * ( (1-(`rhoth'*`rhoth')) + ((`rhoth'*`rhoth')*(1 - `millsx' * (`millsx' - `f'))) ) `if'

		local m1 : word 1 of `varlist'
		local m2 : word 2 of `varlist'
		local m3 : word 3 of `varlist'
		local m4 : word 4 of `varlist'
		local m5 : word 5 of `varlist'
		
		replace `m1' = dv1 - ( 1 - normal(`f') ) `if'
		replace `m2' = dv2 - (`muhd' * normal(`f')) `if'
		replace `m3' = dv3 - (`muhx' * (1-normal(`f'))) `if'
		replace `m4' = dv4 - (((`vhd'*`vhd')+(`muhd'*`muhd')) * normal(`f')) `if'
		replace `m5' = dv5 - (((`vhx'*`vhx')+(`muhx'*`muhx')) * (1-normal(`f'))) `if'
		
}
end
