%%% Elhanan Helpman, Oleg Itskhoki, Marc-Andreas Muendler and Stephen J. Redding (2016): 
%%% "Trade and Inequality: From Theory to Estimantion," Review of Economic Studies, forthcoming

%%% LOCAL 10% GMM BOUNDS COUNTERFACTUALS

%%% Produces Right panel of Figure 2 in the paper
%%% First run GMMBounds.m for ID SET



%% Local counterfactual along the GMM set

% number of draws (use 10M for precision and 100K for fast calculation)
BB = 10000000;      
RV = randn(BB,3);


DATA = [];
tic
for muh0 = muhmin:.01:2.046; % use step 0.01 for precision and step 0.1 for fast calculation

    su0 = sqrt(sH^2 - muh0.^2*Phihat*(1-Phihat) - 2*phihat*muh0 .* (Hbar1-Hbar0-muh0)/(lhat1-lhat0));
    ru0 = (Hbar1-Hbar0-muh0)/(lhat1-lhat0)./su0;
    
    z1 = (cHW*sH*sW - muh0*muw*Phihat*(1-Phihat) - (muh0*rw.*sw + muw*ru0*su0 )*phihat )/su0^2;
    z2 = bhat*(1-ru0^2) + ru0*rw.*sw/su0;
    z3 = muw/muh0;
    z4 = (muw/muh0*su0^2 - sw.^2)/su0^2./(1-muw/muh0);

    [fit0, ind0] = min((z1-z2).^2);
    muw0 = muw(ind0);
    rw0 = rw(ind0);
    sw0 = sw(ind0);
    zeta0 = z1(ind0);
    
    sv0 = sqrt(sw0.^2 - zeta0.^2.*su0.^2);
    rv0 = (rw0.*sw0 - zeta0.*su0.*ru0)./sv0;
    
    [fitc, indc] = min((z1-z3).^2);
    muwc = muw(indc);
    
    pix = (muw0 - bhat*muh0) + (lhat1 + lhat0)*(rw0*sw0 - bhat*ru0*su0 );
    Rw2 = ( (2*z2(ind0)-bhat)*bhat*su0^2 + Phihat*(1-Phihat)*(bhat*muh0+pix)*(2*muw0-bhat*muh0-pix) ...
        + 2*phihat*( bhat*(muw0-bhat*muh0-pix)*ru0*su0 + (bhat*muh0+pix)*rw0*sw0 ) ) ...
        / ( sw0^2 + Phihat*(1-Phihat)*muw0^2 + 2*phihat*muw0*rw0*sw0 ) ;
    
    SIGMA = [su0^2 zeta0*su0^2 ru0*su0; 
             zeta0*su0^2 sw0^2 rw0*sw0;
             ru0*su0 rw0*sw0 1];
         
    SHOCK = (sqrtm(SIGMA)*RV')';
    UU = SHOCK(:,1);
    WW = SHOCK(:,2);
    ZZ = SHOCK(:,3);
    IOTA  = zeros(BB,1);
    IOTA(ZZ>=fhat) = 1; 
    
    VARAUT = mean(WW.^2 .* exp(UU))/mean(exp(UU)) - (mean(WW .* exp(UU))/mean(exp(UU)))^2 ;
    
    VAROPEN = mean((muw0*IOTA+WW).^2 .* exp(muh0*IOTA+UU))/mean(exp(muh0*IOTA+UU)) ...
        - (mean( (muw0*IOTA+WW) .* exp(muh0*IOTA+UU))/mean(exp(muh0*IOTA+UU)))^2 ;
    
    VAROPENcomp = mean((WW).^2 .* exp(muh0*IOTA+UU))/mean(exp(muh0*IOTA+UU)) ...
        - (mean( (WW) .* exp(muh0*IOTA+UU))/mean(exp(muh0*IOTA+UU)))^2 ;
    
    SHH0 = exp(muh0*IOTA+UU)'*IOTA/sum(exp(muh0*IOTA+UU));
    
    
    muh1 = muh0*0.685; % 0.71; %.73 % 0.795
    muw1 = muw0*0.685;
    f1 = fhat - (ru0^2 + rv0^2)/(su0^2+sw0^2) * (log(exp(muh1+muw1)-1)-log(exp(muh0+muw0)-1));
    IOTA1 = zeros(BB,1);
    IOTA1(ZZ>=f1) = 1;
    
    SHH1 = exp(muh1*IOTA1+UU)'*IOTA1/sum(exp(muh1*IOTA1+UU));
    VAROPEN1 = mean((muw1*IOTA1+WW).^2 .* exp(muh1*IOTA1+UU))/mean(exp(muh1*IOTA1+UU)) ...
        - (mean( (muw1*IOTA1+WW) .* exp(muh1*IOTA1+UU))/mean(exp(muh1*IOTA1+UU)))^2 ;
    
    
    muh2 = muh0*0.82;  % 0.795; 
    muw2 = muw0*0.82;
    f2 = fhat - (ru0^2 + rv0^2)/(su0^2+sw0^2) * (log(exp(muh2+muw2)-1)-log(exp(muh0+muw0)-1));
    IOTA2 = zeros(BB,1);
    IOTA2(ZZ>=f2) = 1;
    
    SHH2 = exp(muh2*IOTA2+UU)'*IOTA2/sum(exp(muh2*IOTA2+UU));
    VAROPEN2 = mean((muw2*IOTA2+WW).^2 .* exp(muh2*IOTA2+UU))/mean(exp(muh2*IOTA2+UU)) ...
        - (mean( (muw2*IOTA2+WW) .* exp(muh2*IOTA2+UU))/mean(exp(muh2*IOTA2+UU)))^2 ;
   
    
    DATA = [DATA; [muh0  ru0 muw0 rw(ind0) z1(ind0) fit0 muwc rw(indc) z1(indc) fitc betaimpl pix Rw2 ...
        VARAUT VAROPEN VAROPENcomp  SHH0 SHH1 SHH2 VAROPEN1 VAROPEN2]];

end

toc

MUH = DATA(:,1);
MUW = DATA(:,3);
RU0 = DATA(:,2);
RW0 = DATA(:,4);
ZT0 = DATA(:,5);
VAUT = DATA(:,14);
VOPEN = DATA(:,15);
VOPENc = DATA(:,16);


CF10 = (abs(DATA(:,17)-DATA(:,19)-.1).*(sqrt(VOPEN./DATA(:,20))) ...
    + abs(DATA(:,17)-DATA(:,18)-.1).*(sqrt(VOPEN./DATA(:,21))))./abs(DATA(:,18)-DATA(:,19)) - 1;

figure(22)
plot(DATA(:,1),CF10,'linewidth',3)
hold on
plot([muhmin muhmax],[min(CF10) min(CF10)],'k--','linewidth',1)
plot([muhmin muhmax],[max(CF10) max(CF10)],'k--','linewidth',1)
xlim([muhmin 2.046])
ylim([0 .05])
text(1.25,.024,'Lower bound','FontSize',16,'interpreter','latex')
text(.25,.0335,'Upper bound','FontSize',16,'interpreter','latex')
set(gca,'FontSize',14)
set(gca,'xtick',[muhmin:(2.046-muhmin)/5:2.046])
set(gca,'xticklabel',[0:.2:1])
set(gca,'ytick',[0:.01:.05])
set(gca,'yticklabel',[0:1:10])
xlabel('GMM identified set','FontSize',16,'interpreter','latex')
ylabel('Wage inequality (\% increase)','FontSize',16,'interpreter','latex')

print -depsc BoundsLocal.eps