%%% Elhanan Helpman, Oleg Itskhoki, Marc-Andreas Muendler and Stephen J. Redding (2016): 
%%% "Trade and Inequality: From Theory to Estimantion," Review of Economic Studies, forthcoming

%%% STANDARD ERRORS FOR STRUCTURAL MAXIMUM LIKELIHOOD ESTRIMATES

%%% Function for main file VMC_c.m
%%% calculates second derivative of log-likelihood, or first derivative of score
%%% Input: Theta, x_j  (observation for firm j)
%%% Output: matrix of second derivatives


function [f] = ssj_c(Theta,x);

eps=1e-4;

K = size(Theta,1);

%%% Double-difference of log-likelihood
THETA = Theta*ones(1,K^2);
THETA1=THETA;
THETA2=THETA;
for k1=1:K;
    THETA1(:,(k1-1)*K+1:K*k1) = THETA(:,(k1-1)*K+1:K*k1) + eye(K)*eps;
    THETA2(k1,(k1-1)*K+1:K*k1) = THETA(k1,(k1-1)*K+1:K*k1) + ones(1,K)*eps;
end
THETA12 = THETA1+THETA2-THETA;

% evaluating using log-likelihood, see llj_c.m
f = (llj_c(THETA12,x)-llj_c(THETA1,x)-llj_c(THETA2,x)+llj_c(THETA,x))/(eps^2);

