%%% Second derivative of log likelihood, or first derivative of score
%%% Input: Theta, x_j
%%% Output: KxK matrix of second derivatives
%%% Constrained model with K=9 parameters; mu_w=mu_h*zeta

function [f] = ssj_c(Theta,x);

eps=1e-4;

K = size(Theta,1);

%%% Double-difference of log-likelihood
THETA = Theta*ones(1,K^2);
THETA1=THETA;
THETA2=THETA;
for k1=1:K;
    THETA1(:,(k1-1)*K+1:K*k1) = THETA(:,(k1-1)*K+1:K*k1) + eye(K)*eps;
    THETA2(k1,(k1-1)*K+1:K*k1) = THETA(k1,(k1-1)*K+1:K*k1) + ones(1,K)*eps;
end
THETA12 = THETA1+THETA2-THETA;


f = (llj_c(THETA12,x)-llj_c(THETA1,x)-llj_c(THETA2,x)+llj_c(THETA,x))/(eps^2);


% %%% First difference of score vector
% f=zeros(K,K);
% for k=1:K
%   M=zeros(K,1);
%   M(k,1)=1;
%   f(k,:) = (sj(Theta+eps*M,x) - sj(Theta-eps*M,x))/(2*eps);
% end