
#delimit;

clear;
clear matrix;
set more off;
capture log close;

global dofiles="/home/sjredding/himr-restud/stata/dofiles";
global logs="/home/sjredding/himr-restud/stata/logs";
global input="/data/sjredding/himr-input";
global data="/data/sjredding/himr-restud";
global personal="/home/sjredding/himr-restud/ado";

sysdir set PERSONAL $personal;

log using $logs/condwtvfe/tanova/tanova-raw.log,replace;

***********************************************************;
* Read in Raw Data, Condition on Sample and Save Raw Data *;
***********************************************************;

foreach yr of numlist 1986(1)1998 {;

use $input/rais-secex-all-workers-`yr'.dta, clear;

* Merge region information;

so cnpj_radic pis;
* Merge region data;
merge cnpj_radic using $data/geography/stateidentifiers-`yr'.dta;
tab _merge;
keep if _merge==3;
drop _merge;

* Merge nationality information;
* nacionalidad;
* pis;
* ano;
* identificad;

so pis;
merge pis using $data/nationality/workers-template-`yr'-nacl-clean.dta;
tab _merge;
drop _merge;
so cnpj_radic pis;

* Define sample;

do $dofiles/routines/samplecond.do;

* Generate year;

gen year=`yr';

so cnpj_radic firm_subsibge occup year;
sa $data/condwtvfe/tanova/rawdata-`yr'.dta,replace;

};

***************************************;
**** Merge Raw Firm Files Together ****;
***************************************;

#delimit;
clear;
u $data/condwtvfe/tanova/rawdata-1986.dta;
foreach yr of numlist 1987(1)1998 {;
append using $data/condwtvfe/tanova/rawdata-`yr'.dta;
};
so cnpj_radic firm_subsibge occup year pis;
sa $data/condwtvfe/tanova/rawdata-all.dta, replace;

log close;
