#delimit;
display "Starting sample";
su hhid;

display "Drop non-manufacturing";
display "RAIS: keep if firm_subsibge>=2&firm_subsibge<=13; PNAD: same [based on mapping Ramo to Subsector IBGE]";
keep if firm_subsibge>=2&firm_subsibge<=13;
su hhid;

* Drop observations with missing firm_subsibge code;
display "RAIS: Drop missing firm_subsibge; PNAD: Drop missing firm_subsibge_agg";
display "drop if firm_subsibge==.";
drop if firm_subsibge==.;
su hhid;

* DEFINE SAMPLE;

display "Drop missing wage information";
display "drop if wageyr<=0";
display "drop if wageyr==.";
drop if wageyr<=0;
drop if wageyr==.;
su hhid;

* Keep highest wage for each worker if more than one wage;
display "RAIS: Keep highest wage for each worker if more than one wage";
display "PNAD: Use renda_mensal_ocup_prin (monthly wage in principal occupation)";
* gsort hhid -wageyr;
* quietly by hhid: gen order=_n;
* tab order;
* drop if order>1;
* drop order;
* gen worker=_n;
* su hhid;

* Define variables;

gen lwageyr=ln(wageyr);
gen employ=1;

* Define occupations;

gen occup=.;
replace occup=1 if indprof==1;
replace occup=2 if indtech==1;
replace occup=3 if indwhit==1;
replace occup=4 if indsklb==1;
replace occup=5 if indunsklb==1;

display "Drop if occupation missing";
drop if occup==.;
su hhid;

* Drop based on observables in Mincer regression;

display "Drop based on worker observables";
drop if indchild==.;
drop if indyouth==.;
drop if indadol==.;
drop if indnasc==.;
drop if indearly==.;
drop if indpeak==.;
drop if indlate==.;
drop if indretir==.;
drop if indfem==.;

drop if indhigh==.;
drop if indscoll==.;
drop if indgrad==.;

drop if indprof==.;
drop if indtech==.;
drop if indwhit==.;
drop if indsklb==.;
drop if indunsklb==.;

* drop if temp_empr==.;
su hhid;

* Drop data for small firms with less than five employees;
display "RAIS: Drop data for small firms with less than five employees";
display "PNAD: No such restriction possible; lacking employer information";
* egen firm_emp=count(employ), by(firm_ramo);
* drop if firm_emp<5;
* su hhid;

so hhid;
